import React from "react";
import { FormControl } from "../../..";
import { AbstractControl } from "../../../model";
import { EnumStatusType, IProcessingStatus } from "../../common/model";
export interface IInputContainerRenderInputParams {
    control: FormControl;
    data: any;
    validationStatus: EnumStatusType;
    showErrors: boolean;
}
export declare type IInputContainerPropsRenderLabelParams = {
    showErrors: boolean;
    validationStatus: EnumStatusType;
};
export declare type IInputContainerPropsRenderLabel = (params: IInputContainerPropsRenderLabelParams) => React.ReactFragment;
export declare type IInputContainerPropsRenderInput = (params: IInputContainerRenderInputParams) => React.ReactFragment;
export declare type IInputContainerPropsRenderProcessing = () => React.ReactFragment;
export declare type IInputContainerPropsRenderValidationErrors = (params: {
    errors: any;
    control: AbstractControl;
}) => React.ReactFragment;
export declare type IInputContainerPropsRenderReload = (error: any) => React.ReactFragment;
export declare type IInputContainerPropsShowErrorsFn = (control: AbstractControl) => boolean;
export declare type IInputContainerPropsData = {
    load?: IProcessingStatus;
    renderReload?: IInputContainerPropsRenderReload;
};
export interface IInputContainerProps {
    formLoadStatus?: EnumStatusType;
    control: AbstractControl;
    renderInput: IInputContainerPropsRenderInput;
    data?: IInputContainerPropsData;
    renderProcessing?: IInputContainerPropsRenderProcessing;
    renderLabel?: IInputContainerPropsRenderLabel;
    renderValidationErrors?: IInputContainerPropsRenderValidationErrors;
    showErrorsFn?: IInputContainerPropsShowErrorsFn;
}
