import { mergeMap, Subject } from "rxjs";
import { ProcessingType } from "../../common/model";
import { IAsyncCallConfigProps, IAsyncCallExecuteProps, IAsyncCallState, SetDataType } from "./model";
export declare const initialStateAsyncCall: IAsyncCallState;
export declare const getTypeOperation: (processingType: ProcessingType) => typeof mergeMap;
export declare class AsyncCall<P, D> {
    private executeFn$;
    private config;
    private setState;
    destroy$: Subject<void>;
    private execute$;
    newState: IAsyncCallState<D, P>;
    private setData$Subject;
    constructor(executeFn$: IAsyncCallExecuteProps<D, P>, config: IAsyncCallConfigProps<D, P>, setState: (a: (prevState: IAsyncCallState<D, P>) => IAsyncCallState<D, P>) => void, destroy$: Subject<void>);
    getStatus(): import("../../common/model").EnumStatusType;
    private initSetData;
    init(): void;
    getState(): IAsyncCallState<D, P>;
    reload(): void;
    get execute(): (params: P) => void;
    get setData(): SetDataType<D>;
}
