"use strict";

exports.__esModule = true;
exports.useAsyncCall = void 0;

var _react = require("react");

var _AsyncCall = require("./AsyncCall");

const useAsyncCall = (executeFn, config) => {
  const [, setState] = (0, _react.useState)(_AsyncCall.initialStateAsyncCall);
  const asyncCallRef = (0, _react.useRef)(new _AsyncCall.AsyncCall(executeFn, config, setState, null));
  const asyncCall = asyncCallRef.current;
  (0, _react.useEffect)(() => {
    asyncCall.init();
    return () => {
      asyncCall.destroy$.next();
      asyncCall.destroy$.complete();
    };
  }, [asyncCall]);
  const status = asyncCall.newState.status;
  return {
    data: status.data,
    error: status.error,
    isLoading: status.status === 'PROCESSING',
    isSuccess: status.status === 'SUCCESS',
    execute: asyncCall.execute,
    reload: asyncCall.reload,
    status: asyncCall.getStatus(),
    getState: asyncCall.getState,
    isError: status.status === 'ERROR',
    setData: asyncCall.setData,
    ref: asyncCallRef,
    allErrors: asyncCall.newState.errors
  };
};

exports.useAsyncCall = useAsyncCall;