"use strict";

exports.__esModule = true;
exports.useObservableSubscribe = void 0;

var _react = require("react");

var _rxjs = require("rxjs");

var _immer = require("immer");

const useObservableSubscribe = props => {
  const [state, setState] = (0, _react.useState)({});
  const destroy$Ref = (0, _react.useRef)(props.destroy$ ? props.destroy$ : new _rxjs.Subject());
  const obs$ = props.obs$;
  const destroy$ = destroy$Ref.current;
  (0, _react.useEffect)(() => {
    obs$.pipe((0, _rxjs.takeUntil)(destroy$), (0, _rxjs.tap)(value => {
      setState((0, _immer.produce)(draft => {
        draft.value = value;
      }));
    }, error => {
      setState((0, _immer.produce)(draft => {
        draft.error = error;
      }));
    }, () => {
      setState((0, _immer.produce)(draft => {
        draft.completed = true;
      }));
    })).subscribe();
    return () => {
      destroy$.next();
      destroy$.complete();
    };
  }, [obs$, destroy$]);
  return state;
};

exports.useObservableSubscribe = useObservableSubscribe;